import{s as Ae,o as Ee,n as Ce}from"../chunks/scheduler.c57aa7ef.js";import{S as Re,i as Fe,g as s,s as o,r as F,A as qe,h as r,f as i,c as a,j as xe,u as q,x as p,k as Pe,y as Ie,a as l,v as I,d as U,t as j,w as z}from"../chunks/index.394f8801.js";import{T as ke}from"../chunks/Tip.23dfb1a9.js";import{H as pe,E as Ue}from"../chunks/EditOnGithub.157fddbf.js";function je(G){let n,u="Unless indicated otherwise, the default <code>torch.compile</code> settings were used.";return{c(){n=s("p"),n.innerHTML=u},l(c){n=r(c,"P",{"data-svelte-h":!0}),p(n)!=="svelte-11mpuzm"&&(n.innerHTML=u)},m(c,d){l(c,n,d)},p:Ce,d(c){c&&i(n)}}}function ze(G){let n,u="If you have another use case where you know that <code>torch.compile</code> does or does not work with PEFT, please contribute by letting us know or by opening a PR to add this use case to the covered test cases.";return{c(){n=s("p"),n.innerHTML=u},l(c){n=r(c,"P",{"data-svelte-h":!0}),p(n)!=="svelte-fo45pn"&&(n.innerHTML=u)},m(c,d){l(c,n,d)},p:Ce,d(c){c&&i(n)}}}function Ge(G){let n,u,c,d,h,S,w,ue='In PEFT, <a href="https://pytorch.org/tutorials/intermediate/torch_compile_tutorial.html" rel="nofollow">torch.compile</a> works for some but not all features. The reason why it won’t always work is because PEFT is highly dynamic in certain places (loading and switching between multiple adapters, for instance), which can cause trouble for <code>torch.compile</code>. In other places, <code>torch.compile</code> may work, but won’t be as fast as expected because of graph breaks.',B,$,de="If you don’t see an error, it doesn’t necessarily mean that <code>torch.compile</code> worked correctly. It might give you an output, but the output is incorrect. This guide describes what works with <code>torch.compile</code> and what doesn’t.",D,f,K,g,N,T,fe="These features <strong>work</strong> with <code>torch.compile</code>. Everything listed below was tested with a causal LM:",V,_,me="<li>Training with <code>Trainer</code> from 🤗 transformers</li> <li>Training with a custom PyTorch loop</li> <li>Inference</li> <li>Generation</li>",J,v,he="The following adapters were tested successfully:",Q,L,we="<li>AdaLoRA</li> <li>BOFT</li> <li>IA³</li> <li>Layer Norm Tuning</li> <li>LoHa</li> <li>LoRA</li> <li>LoRA + DoRA</li> <li>OFT</li> <li>VeRA</li> <li>HRA</li>",W,b,$e="The following adapters <strong>don’t work</strong> correctly for training or inference when using <code>torch.compile</code>:",X,y,ge="<li>LoKr</li> <li>LoRA targeting embedding layers</li>",Y,M,Z,H,Te="Below are some of the more advanced PEFT features that <strong>work</strong>. They were all tested with LoRA.",ee,x,_e="<li><code>modules_to_save</code> (i.e. <code>config = LoraConfig(..., modules_to_save=...)</code>)</li> <li>Merging adapters (one or multiple)</li> <li>Merging multiple adapters into one adapter (i.e. calling <code>model.add_weighted_adapter(...)</code>)</li>",te,P,ve="Generally, we can expect that if a feature works correctly with LoRA and is also supported by other adapter types, it should also work for that adapter type.",ie,k,Le="The more advanced PEFT features below <strong>don’t work</strong> in conjunction with <code>torch.compile</code>. Tests were run with LoRA:",le,C,be="<li>Using PEFT adapters with quantization (bitsandbytes)</li> <li>Inference with multiple adapters</li> <li>Unloading (i.e. calling <code>model.merge_and_unload()</code>)</li> <li>Disabling adapters (i.e. using <code>with model.disable_adapter()</code>)</li> <li>Mixed adapter batches (i.e. calling <code>model(batch, adapter_names=[&quot;__base__&quot;, &quot;default&quot;, &quot;other&quot;, ...])</code>)</li>",ne,A,oe,E,ye='All the use cases listed above are tested inside of <a href="https://github.com/huggingface/peft/blob/main/tests/test_torch_compile.py" rel="nofollow"><code>peft/tests/test_torch_compile.py</code></a>. If you want to check in more detail how we tested a certain feature, please go to that file and check the test that corresponds to your use case.',ae,m,se,R,re,O,ce;return h=new pe({props:{title:"torch.compile",local:"torchcompile",headingTag:"h1"}}),f=new ke({props:{warning:!1,$$slots:{default:[je]},$$scope:{ctx:G}}}),g=new pe({props:{title:"Training and inference with torch.compile",local:"training-and-inference-with-torchcompile",headingTag:"h2"}}),M=new pe({props:{title:"Advanced PEFT features with torch.compile",local:"advanced-peft-features-with-torchcompile",headingTag:"h2"}}),A=new pe({props:{title:"Test cases",local:"test-cases",headingTag:"h2"}}),m=new ke({props:{warning:!1,$$slots:{default:[ze]},$$scope:{ctx:G}}}),R=new Ue({props:{source:"https://github.com/huggingface/peft/blob/main/docs/source/developer_guides/torch_compile.md"}}),{c(){n=s("meta"),u=o(),c=s("p"),d=o(),F(h.$$.fragment),S=o(),w=s("p"),w.innerHTML=ue,B=o(),$=s("p"),$.innerHTML=de,D=o(),F(f.$$.fragment),K=o(),F(g.$$.fragment),N=o(),T=s("p"),T.innerHTML=fe,V=o(),_=s("ul"),_.innerHTML=me,J=o(),v=s("p"),v.textContent=he,Q=o(),L=s("ul"),L.innerHTML=we,W=o(),b=s("p"),b.innerHTML=$e,X=o(),y=s("ul"),y.innerHTML=ge,Y=o(),F(M.$$.fragment),Z=o(),H=s("p"),H.innerHTML=Te,ee=o(),x=s("ul"),x.innerHTML=_e,te=o(),P=s("p"),P.textContent=ve,ie=o(),k=s("p"),k.innerHTML=Le,le=o(),C=s("ul"),C.innerHTML=be,ne=o(),F(A.$$.fragment),oe=o(),E=s("p"),E.innerHTML=ye,ae=o(),F(m.$$.fragment),se=o(),F(R.$$.fragment),re=o(),O=s("p"),this.h()},l(e){const t=qe("svelte-u9bgzb",document.head);n=r(t,"META",{name:!0,content:!0}),t.forEach(i),u=a(e),c=r(e,"P",{}),xe(c).forEach(i),d=a(e),q(h.$$.fragment,e),S=a(e),w=r(e,"P",{"data-svelte-h":!0}),p(w)!=="svelte-1epca12"&&(w.innerHTML=ue),B=a(e),$=r(e,"P",{"data-svelte-h":!0}),p($)!=="svelte-1alfwjj"&&($.innerHTML=de),D=a(e),q(f.$$.fragment,e),K=a(e),q(g.$$.fragment,e),N=a(e),T=r(e,"P",{"data-svelte-h":!0}),p(T)!=="svelte-10kwh8m"&&(T.innerHTML=fe),V=a(e),_=r(e,"UL",{"data-svelte-h":!0}),p(_)!=="svelte-1bf32c1"&&(_.innerHTML=me),J=a(e),v=r(e,"P",{"data-svelte-h":!0}),p(v)!=="svelte-1u6npfd"&&(v.textContent=he),Q=a(e),L=r(e,"UL",{"data-svelte-h":!0}),p(L)!=="svelte-8zg1lj"&&(L.innerHTML=we),W=a(e),b=r(e,"P",{"data-svelte-h":!0}),p(b)!=="svelte-c97aay"&&(b.innerHTML=$e),X=a(e),y=r(e,"UL",{"data-svelte-h":!0}),p(y)!=="svelte-iv8nd2"&&(y.innerHTML=ge),Y=a(e),q(M.$$.fragment,e),Z=a(e),H=r(e,"P",{"data-svelte-h":!0}),p(H)!=="svelte-gy3aka"&&(H.innerHTML=Te),ee=a(e),x=r(e,"UL",{"data-svelte-h":!0}),p(x)!=="svelte-1oglq83"&&(x.innerHTML=_e),te=a(e),P=r(e,"P",{"data-svelte-h":!0}),p(P)!=="svelte-x3yaa4"&&(P.textContent=ve),ie=a(e),k=r(e,"P",{"data-svelte-h":!0}),p(k)!=="svelte-18hj1j5"&&(k.innerHTML=Le),le=a(e),C=r(e,"UL",{"data-svelte-h":!0}),p(C)!=="svelte-58pk2s"&&(C.innerHTML=be),ne=a(e),q(A.$$.fragment,e),oe=a(e),E=r(e,"P",{"data-svelte-h":!0}),p(E)!=="svelte-1ks3zgv"&&(E.innerHTML=ye),ae=a(e),q(m.$$.fragment,e),se=a(e),q(R.$$.fragment,e),re=a(e),O=r(e,"P",{}),xe(O).forEach(i),this.h()},h(){Pe(n,"name","hf:doc:metadata"),Pe(n,"content",Oe)},m(e,t){Ie(document.head,n),l(e,u,t),l(e,c,t),l(e,d,t),I(h,e,t),l(e,S,t),l(e,w,t),l(e,B,t),l(e,$,t),l(e,D,t),I(f,e,t),l(e,K,t),I(g,e,t),l(e,N,t),l(e,T,t),l(e,V,t),l(e,_,t),l(e,J,t),l(e,v,t),l(e,Q,t),l(e,L,t),l(e,W,t),l(e,b,t),l(e,X,t),l(e,y,t),l(e,Y,t),I(M,e,t),l(e,Z,t),l(e,H,t),l(e,ee,t),l(e,x,t),l(e,te,t),l(e,P,t),l(e,ie,t),l(e,k,t),l(e,le,t),l(e,C,t),l(e,ne,t),I(A,e,t),l(e,oe,t),l(e,E,t),l(e,ae,t),I(m,e,t),l(e,se,t),I(R,e,t),l(e,re,t),l(e,O,t),ce=!0},p(e,[t]){const Me={};t&2&&(Me.$$scope={dirty:t,ctx:e}),f.$set(Me);const He={};t&2&&(He.$$scope={dirty:t,ctx:e}),m.$set(He)},i(e){ce||(U(h.$$.fragment,e),U(f.$$.fragment,e),U(g.$$.fragment,e),U(M.$$.fragment,e),U(A.$$.fragment,e),U(m.$$.fragment,e),U(R.$$.fragment,e),ce=!0)},o(e){j(h.$$.fragment,e),j(f.$$.fragment,e),j(g.$$.fragment,e),j(M.$$.fragment,e),j(A.$$.fragment,e),j(m.$$.fragment,e),j(R.$$.fragment,e),ce=!1},d(e){e&&(i(u),i(c),i(d),i(S),i(w),i(B),i($),i(D),i(K),i(N),i(T),i(V),i(_),i(J),i(v),i(Q),i(L),i(W),i(b),i(X),i(y),i(Y),i(Z),i(H),i(ee),i(x),i(te),i(P),i(ie),i(k),i(le),i(C),i(ne),i(oe),i(E),i(ae),i(se),i(re),i(O)),i(n),z(h,e),z(f,e),z(g,e),z(M,e),z(A,e),z(m,e),z(R,e)}}}const Oe='{"title":"torch.compile","local":"torchcompile","sections":[{"title":"Training and inference with torch.compile","local":"training-and-inference-with-torchcompile","sections":[],"depth":2},{"title":"Advanced PEFT features with torch.compile","local":"advanced-peft-features-with-torchcompile","sections":[],"depth":2},{"title":"Test cases","local":"test-cases","sections":[],"depth":2}],"depth":1}';function Se(G){return Ee(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ve extends Re{constructor(n){super(),Fe(this,n,Se,Ge,Ae,{})}}export{Ve as component};
